<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\master_worker_credential;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\master_worker_credential\MasterWorkerCredentialImages;
use app\common\lists\ListsSearchInterface;
use app\common\model\master_worker_register\MasterWorkerRegister;


/**
 * MasterWorkerCredentialImages列表
 * Class MasterWorkerCredentialImagesLists
 * @package app\adminapi\lists
 */
class MasterWorkerCredentialImagesLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/10/16 16:31
     */
    public function setSearch(): array
    {
        return [
            '=' => ['worker_register_id'],
        ];
    }
    public function queryWhere(): array
    {
        $where = [];
        if(isset($this->params['start_time']) && !empty($this->params['start_time'])){
            $where[] = ['start_time', '>=', $this->params['start_time']];
        }
        if(isset($this->params['end_time']) && !empty($this->params['end_time'])){
            $where[] = ['end_time', '<=', $this->params['end_time']];
        }
        if (isset($this->params['name']) && !empty($this->params['name'])) {
            $worker_register_ids = MasterWorkerRegister::where('name', 'like', '%' . $this->params['name'] . '%')->column('id');
            $where[] = ['worker_register_id', 'IN', $worker_register_ids?:[0]];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/10/16 16:31
     */
    public function lists(): array
    {
        return MasterWorkerCredentialImages::where($this->searchWhere)->where($this->queryWhere())
            ->field(['*'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/10/16 16:31
     */
    public function count(): int
    {
        return MasterWorkerCredentialImages::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}